#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

//The output from this program was originally intended to be bzipped for the distribution. However, this program turned out to be faster than bunzip2. Oh well.
//900K is the block size used by bzip2 -9. We write out two such blocks (= 1.8 MB) at a time.
#ifndef RUNSIZE
#	define RUNSIZE 900000U
#endif
enum { run_size = RUNSIZE, buf_size = run_size * 2U };

int main(void) {
	fputs("Writing 6.5484 GB of test data. This takes about three minutes on my Cube with an upgraded hard drive.\n", stderr);

	//Generate four thousand runs of run_size bytes each.
	//The runs alternate between 'AAAAA...' and 'BBBBB...'.
	char *buf = malloc(buf_size);
	memset(buf, 'A', run_size);
	memset(&buf[run_size], 'B', run_size);

	//Write two runs at a time. 3638 iterations * 2 runs per write = 7276 runs.
	for(register unsigned i = 0U; i < 3638U; ++i)
		write(STDOUT_FILENO, buf, buf_size);

	free(buf);
	return 0;
}
